@echo off
REM /*
REM	Der freundliche und einfache DHCP-Synchronisator
REM	=================================================
REM 	20130812 b.stromberg@data-systems.de / http://ugg.li
REM
REM 	Holt DHCP-Reservierungen von einem Quell-DHCP-Server und fuegt diese
REM 	in einen anderen Ziel-DHCP-Server ein. Gebaut fuer Server 2008R2 (Quelle/Ziel).
REM
REM	- Benoetigt SED aus den GnuTools (http://gnuwin32.sourceforge.net/packages/sed.htm)
REM	  sed.exe muss in .\bin liegen
REM	- Loescht vor dem Import alle bestehenden Reservierungen aus dem Zielserver
REM
REM	Keine Garantie, Gewaehr oder Support (vielleicht wenn du freundlich fragst). Mach mit
REM	dem Script was du willst, ausgenommen den Einsatz bei Waffen- und Militaersystemen und
REM	der GEMA.
REM */


REM --- Quellserver (Netbios-Name)
set quellserver=SOURCE

REM --- Zielserver (Netbios-Name)
set zielserver=DESTINATION

REM --- Starte hier (Das Script muss hier schreiben duerfen und SED muss in .\bin\ liegen)
c: & cd "C:\Program Files\scripts"

REM --- Scope (Bereich, IP-Adresse)
set scope=172.16.0.0


REM ------------------------------------------------------------------

REM --- Ist sed.exe auch wirklich da?
if not exist bin\sed.exe goto error_keinsed

REM --- Reservierte Adressen (gefiltert) abholen
netsh dhcp server \\%quellserver% dump | find /i "Add reservedip" >dhcp-reservedip.txt

REM --- Servernamen (UNC) austauschen
bin\sed -e "s/[\][\]%quellserver%/\\\\%zielserver%/" < dhcp-reservedip.txt > dhcp-reservedipchanged.txt
del dhcp-reservedip.txt

REM --- Bestehende Reservierungen aus ZIEL-Server holen und filtern (zum loeschen)
netsh dhcp server scope %scope% show reservedip |find /i "%scope:~0,4%"  | find /i " - " >deletethesereservedips.txt

REM --- Bestehende Reservierungen "-" aus der MAC entfernen, damit netsh die MAC beim loeschen auch versteht
if exist deletethesereservedipsclean.txt del deletethesereservedipsclean.txt
for /f "tokens=1,3 delims= " %%i in (deletethesereservedips.txt) do (
echo %%i %%j | bin\sed.exe -e "s/-//g" >>deletethesereservedipsclean.txt
)
del deletethesereservedips.txt

REM --- Bestehende Reservierungen loeschen
for /f "delims= tokens=1,2" %%i in (deletethesereservedipsclean.txt) do (
netsh dhcp server scope %scope% delete reservedip %%i %%j
)
del deletethesereservedipsclean.txt

REM --- Und endlich die Reservierungen vom Quellserver importieren
netsh < dhcp-reservedipchanged.txt
del dhcp-reservedipchanged.txt

goto eof

REM ------ Fehler

:error_keinsed
echo Fehler: sed.exe konnte nicht gefunden werden:
echo         %cd%\bin\sed.exe
echo         Download unter: http://gnuwin32.sourceforge.net/packages/sed.htm
goto eof

:eof
